; -------------------------------------------------------------------------
;	Project     : Masm32 DLL
;	File name   : vbdll_Example.asm
;	File created: 07-04-2007  10:18
;	Last Update : 07-04-2007  10:18
;	File type   : macro assembler source code
;	Usage	    : tutorial vb-asm framework for learning masm32
; _________________________________________________________________________

.386
.model flat,stdcall
option casemap:none

include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
includelib	\masm32\lib\user32.lib
include		\masm32\include\kernel32.inc
includelib	\masm32\lib\kernel32.lib


.data

.code
; ========================================================================
DllEntry PROC hInstDLL:HINSTANCE, reason:DWORD, reserved1:DWORD

	
; ------===
        mov  eax,TRUE
        ret
DllEntry ENDP
; ========================================================================
ManipulateBinaryBuffer PROC uses ebx ecx edx esi edi lpBinaryBuffer:DWORD,lenBinaryBuffer:DWORD

	cmp lenBinaryBuffer,0
	je  MBB_Exit

	mov esi,lpBinaryBuffer
	xor ebx,ebx
	mov eax,021h
	@@:
	add byte ptr[esi+ebx],al
	inc al
	inc ebx
	cmp ebx,lenBinaryBuffer
	jne @B	
; ------===
MBB_Exit:
	mov eax,0
	ret
ManipulateBinaryBuffer ENDP
; ------------------------------------------------------------------------
Add2Values PROC uses ebx ecx edx esi edi value1:DWORD,value2:DWORD

	mov eax,value1
	add eax,value2
	ret
Add2Values ENDP

CallWindowsAPI_MessageBox PROC uses ebx ecx edx esi edi lpszText:DWORD,lpszCaption:DWORD

	invoke MessageBox,0,lpszText,lpszCaption,MB_OK or MB_ICONINFORMATION
	mov eax,0	
	ret

CallWindowsAPI_MessageBox ENDP

ScrollTextExample PROC uses ebx ecx edx esi edi lpBuffer:DWORD,lenBuffer:DWORD
	
	cmp lenBuffer,0
	je STE_Exit
	
	mov esi,lpBuffer
	xor ebx,ebx
	mov cl,byte ptr[esi+ebx]
	@@:
	mov al,byte ptr[esi+ebx+1]
	mov byte ptr[esi+ebx],al
	inc ebx
	cmp ebx,lenBuffer
	jne  @B
	mov byte ptr[esi+ebx-1],cl
STE_Exit:	
	mov eax,0	
	ret

ScrollTextExample endp



; ========================================================================
End DllEntry
